/*
半田ごてタイマープログラム
*/
#define TIMER_COUNT 60    //タイマー時間
#define TIMER_ALART_COUNT TIMER_COUNT-5

const int startbuttonPin = 5;     // Timer start button
const int stopbuttonPin = 4;     // Timer stop button
const int ledPin =  6;      // Status LED pin
const int ac_ctrlPin =  7;      // AC ctrl signal pin
const int BZ_outPin =  3;      // AC ctrl signal pin

// variables will change:
int PowerState = 0;         // variable for reading the pushbutton status
int timer_count_min;
int timer_count_msec;
int timer_count_sec;

void setup() {
  // ＩＯ初期化
  pinMode(ledPin, OUTPUT);      
  pinMode(ac_ctrlPin, OUTPUT);      
  pinMode(startbuttonPin, INPUT_PULLUP);     
  pinMode(stopbuttonPin, INPUT_PULLUP);     
  digitalWrite(ledPin, LOW);  
  digitalWrite(ac_ctrlPin, LOW);  
  timer_count_min=0;
  timer_count_sec=0;
  PowerState=0;
}


void loop(){
  
  while(PowerState!=1)  //スタンバイ時タスク 本来==0で良いが、01以外で何も機能しなくなるため保険
  {
    // スタートボタンが押された
    if (digitalRead(startbuttonPin) == LOW) {     
      // ＬＥＤつける:    
      PowerState=1;
      digitalWrite(ledPin, HIGH);  
      digitalWrite(ac_ctrlPin, HIGH);
      tone(BZ_outPin, 1000,50);
      delay(50);
      tone(BZ_outPin, 2000,50);
        // カウンタ初期化
      timer_count_min=0;
      timer_count_sec=0;
      timer_count_msec=0;
    } 
  }
  
  while(PowerState==1) //通電時タスク
  {
    delay(100);
    timer_count_msec++;
    if(timer_count_min>=TIMER_ALART_COUNT) //5分前にLEDを点滅させる
    {
        if (digitalRead(startbuttonPin) == LOW) { //5分前にボタンが押されたら延長
          timer_count_min=0;
        }
       if (digitalRead(ledPin) == HIGH) // LED状態反転
          digitalWrite(ledPin, LOW);
       else
          digitalWrite(ledPin, HIGH);
    }
    if(timer_count_msec>=10)
    {
      timer_count_msec=0;
      timer_count_sec++;
      if(timer_count_sec>=60)  //1分置きの処理
      {
        timer_count_sec=0;
        timer_count_min++;
        if(timer_count_min==TIMER_ALART_COUNT) //5分前にブザーを鳴らす
        {
          tone(BZ_outPin, 2000,50);
          delay(100);
          tone(BZ_outPin, 2000,50);         
          delay(100);
          tone(BZ_outPin, 2000,50);         
        }
        if(timer_count_min>TIMER_COUNT)
        {
            timer_count_min=0;
            PowerState=0;
            digitalWrite(ledPin, LOW); 
            digitalWrite(ac_ctrlPin, LOW); 
            tone(BZ_outPin, 2000,50);
            delay(50);
            tone(BZ_outPin, 1000,50);
        }
      }
    }

    // ストップボタンが押された
    if (digitalRead(stopbuttonPin) == LOW) {     
      // ＬＥＤけす:
      PowerState=0;
      digitalWrite(ledPin, LOW); 
      digitalWrite(ac_ctrlPin, LOW); 
      tone(BZ_outPin, 2000,50);
      delay(50);
      tone(BZ_outPin, 1000,50);
    }
  }  
} 

