#include "SPI.h"

#define VCC  8
#define GND  9
#define SLAVE  10

#define TEMP_HI  250   //上限温度
#define TEMP_LO  230  //加熱復帰温度

const int startbuttonPin = 5;     // Timer start button
const int stopbuttonPin = 4;     // Timer stop button
const int ledPin =  6;      // Status LED pin
const int ac_ctrlPin =  7;      // AC ctrl signal pin
const int BZ_outPin =  3;      // AC ctrl signal pin


void setup() {
#ifdef GND
  pinMode(GND, OUTPUT);
  digitalWrite(GND, LOW); 
#endif
#ifdef VCC
  pinMode(VCC, OUTPUT);
  digitalWrite(VCC, HIGH);
#endif
  pinMode(SLAVE, OUTPUT);
  digitalWrite(SLAVE, HIGH);

  Serial.begin(9600);
  SPI.begin();
  SPI.setBitOrder(MSBFIRST);
  SPI.setClockDivider(SPI_CLOCK_DIV4);
  SPI.setDataMode(SPI_MODE0);

//コントロール用IO
  pinMode(ledPin, OUTPUT);      
  pinMode(ac_ctrlPin, OUTPUT);      
  pinMode(startbuttonPin, INPUT_PULLUP);     
  pinMode(stopbuttonPin, INPUT_PULLUP);     
  digitalWrite(ledPin, LOW);  
  digitalWrite(ac_ctrlPin, LOW);  
}

void loop() {
  int value,temp;

  delay(500);
  digitalWrite(SLAVE, LOW);        //  Enable a chip
  value = SPI.transfer(0x00) << 8;  //  read High byte
  value |= SPI.transfer(0x00);      //  read Low byte
  digitalWrite(SLAVE, HIGH);         //  Desavle a chip
  
  if ((value & 0x0004) != 0){
    Serial.println("Error");
  } else {
    Serial.println((value >> 3) * 0.25);
    
    temp=(value >> 3) * 0.25;
    if(temp>TEMP_HI)    //基準温度を超えるとOFFにする
    {
      digitalWrite(ac_ctrlPin, LOW); 
  digitalWrite(ledPin, LOW);  
    }
    if(temp<TEMP_LO)    //基準温度を下回るとONにする
    {
      digitalWrite(ac_ctrlPin, HIGH); 
  digitalWrite(ledPin, HIGH);  
    }
  }
}

